package apis

import (
	"fmt"

	"github.com/gin-gonic/gin"
	"github.com/gin-gonic/gin/binding"
	"github.com/go-admin-team/go-admin-core/sdk/api"
	"github.com/go-admin-team/go-admin-core/sdk/pkg/jwtauth/user"
	_ "github.com/go-admin-team/go-admin-core/sdk/pkg/response"

	"go-admin/app/admin/models"
	"go-admin/app/admin/service"
	"go-admin/app/admin/service/dto"
	"go-admin/common/actions"
)

type MemberRenwaLog struct {
	api.Api
}

// GetPage 获取会员续期记录列表
// @Summary 获取会员续期记录列表
// @Description 获取会员续期记录列表
// @Tags 会员续期记录
// @Param pageSize query int false "页条数"
// @Param pageIndex query int false "页码"
// @Success 200 {object} response.Response{data=response.Page{list=[]models.MemberRenwaLog}} "{"code": 200, "data": [...]}"
// @Router /api/v1/member-renwa-log [get]
// @Security Bearer
func (e MemberRenwaLog) GetPage(c *gin.Context) {
	req := dto.MemberRenwaLogGetPageReq{}
	s := service.MemberRenwaLog{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req, binding.Form, binding.Query).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}

	p := actions.GetPermissionFromContext(c)
	list := make([]models.MemberRenwaLog, 0)
	var count int64

	err = s.GetPage(&req, p, &list, &count)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取会员续期记录失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.PageOK(list, int(count), req.GetPageIndex(), req.GetPageSize(), "查询成功")
}

// Get 获取会员续期记录
// @Summary 获取会员续期记录
// @Description 获取会员续期记录
// @Tags 会员续期记录
// @Param id path int false "id"
// @Success 200 {object} response.Response{data=models.MemberRenwaLog} "{"code": 200, "data": [...]}"
// @Router /api/v1/member-renwa-log/{id} [get]
// @Security Bearer
func (e MemberRenwaLog) Get(c *gin.Context) {
	req := dto.MemberRenwaLogGetReq{}
	s := service.MemberRenwaLog{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	var object models.MemberRenwaLog

	p := actions.GetPermissionFromContext(c)
	err = s.Get(&req, p, &object)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取会员续期记录失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.OK(object, "查询成功")
}

// Insert 创建会员续期记录
// @Summary 创建会员续期记录
// @Description 创建会员续期记录
// @Tags 会员续期记录
// @Accept application/json
// @Product application/json
// @Param data body dto.MemberRenwaLogInsertReq true "data"
// @Success 200 {object} response.Response	"{"code": 200, "message": "添加成功"}"
// @Router /api/v1/member-renwa-log [post]
// @Security Bearer
func (e MemberRenwaLog) Insert(c *gin.Context) {
	req := dto.MemberRenwaLogInsertReq{}
	s := service.MemberRenwaLog{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	// 设置创建人
	req.SetCreateBy(user.GetUserId(c))

	err = s.Insert(&req)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("创建会员续期记录失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.OK(req.GetId(), "创建成功")
}

// Update 修改会员续期记录
// @Summary 修改会员续期记录
// @Description 修改会员续期记录
// @Tags 会员续期记录
// @Accept application/json
// @Product application/json
// @Param id path int true "id"
// @Param data body dto.MemberRenwaLogUpdateReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "修改成功"}"
// @Router /api/v1/member-renwa-log/{id} [put]
// @Security Bearer
func (e MemberRenwaLog) Update(c *gin.Context) {
	req := dto.MemberRenwaLogUpdateReq{}
	s := service.MemberRenwaLog{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Update(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("修改会员续期记录失败，\r\n失败信息 %s", err.Error()))
		return
	}
	e.OK(req.GetId(), "修改成功")
}

// Delete 删除会员续期记录
// @Summary 删除会员续期记录
// @Description 删除会员续期记录
// @Tags 会员续期记录
// @Param data body dto.MemberRenwaLogDeleteReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "删除成功"}"
// @Router /api/v1/member-renwa-log [delete]
// @Security Bearer
func (e MemberRenwaLog) Delete(c *gin.Context) {
	s := service.MemberRenwaLog{}
	req := dto.MemberRenwaLogDeleteReq{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}

	// req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Remove(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("删除会员续期记录失败，\r\n失败信息 %s", err.Error()))
		return
	}
	e.OK(req.GetId(), "删除成功")
}
